// ImageTool.cpp :  α׷  Ŭ  մϴ.
//

#include "stdafx.h"
#include "ImageTool.h"
#include "MainFrm.h"

#include "ChildFrm.h"
#include "ImageToolDoc.h"
#include "ImageToolView.h"

#include "AviChildFrame.h"
#include "AviDoc.h"
#include "AviView.h"

#include "Dib.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CImageToolApp

BEGIN_MESSAGE_MAP(CImageToolApp, CWinApp)
	ON_COMMAND(ID_APP_ABOUT, &CImageToolApp::OnAppAbout)
	// ǥ  ʷ ϴ  Դϴ.
	ON_COMMAND(ID_FILE_NEW, &CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, &CWinApp::OnFileOpen)
	// ǥ μ  Դϴ.
	ON_COMMAND(ID_FILE_PRINT_SETUP, &CWinApp::OnFilePrintSetup)
	ON_COMMAND(ID_EDIT_PASTE, &CImageToolApp::OnEditPaste)
	ON_UPDATE_COMMAND_UI(ID_EDIT_PASTE, &CImageToolApp::OnUpdateEditPaste)
	ON_COMMAND(ID_WINDOW_CLOSEALL, &CImageToolApp::OnWindowCloseall)
END_MESSAGE_MAP()


// CImageToolApp 

CImageToolApp::CImageToolApp()
: m_pNewDib(NULL), m_pImageDocTemplate(NULL), m_pAviDocTemplate(NULL)
{
}

CImageToolApp::~CImageToolApp()
{
	if( m_pNewDib != NULL )
		delete m_pNewDib;
}


//  CImageToolApp üԴϴ.

CImageToolApp theApp;


// CImageToolApp ʱȭ

BOOL CImageToolApp::InitInstance()
{
	//  α׷ Ŵ佺Ʈ ComCtl32.dll  6 ̻ Ͽ ־ Ÿ
	// ϵ ϴ , Windows XP 󿡼 ݵ InitCommonControlsEx() ʿմϴ. 
	// InitCommonControlsEx()   â   ϴ.
	INITCOMMONCONTROLSEX InitCtrls;
	InitCtrls.dwSize = sizeof(InitCtrls);

	//  α׷    Ʈ Ŭ ϵ
	//  ׸ Ͻʽÿ.
	InitCtrls.dwICC = ICC_WIN95_CLASSES;
	InitCommonControlsEx(&InitCtrls);

	CWinApp::InitInstance();

	// OLE ̺귯 ʱȭմϴ.
	if (!AfxOleInit())
	{
		AfxMessageBox(IDP_OLE_INIT_FAILED);
		return FALSE;
	}
	AfxEnableControlContainer();

	// ǥ ʱȭ
	// ̵   ʰ    ũ⸦ ̷
	// Ʒ ʿ  Ư ʱȭ
	// ƾ ؾ մϴ.
	// ش   Ʈ Ű Ͻʽÿ.
	// TODO:  ڿ ȸ Ǵ  ̸ 
	//   ؾ մϴ.
	SetRegistryKey(_T("  α׷ 翡   α׷"));

	LoadStdProfileSettings(4);  // MRU Ͽ ǥ INI  ɼ εմϴ.

	//  α׷  ø մϴ.  ø
	//  ,  â      մϴ.
	m_pImageDocTemplate = new CMultiDocTemplate(IDR_ImageToolTYPE,
		RUNTIME_CLASS(CImageToolDoc),
		RUNTIME_CLASS(CChildFrame), //   MDI ڽ Դϴ.
		RUNTIME_CLASS(CImageToolView));
	if (!m_pImageDocTemplate)
		return FALSE;
	AddDocTemplate(m_pImageDocTemplate);

	m_pAviDocTemplate = new CMultiDocTemplate(IDR_AVI_TYPE,
		RUNTIME_CLASS(CAviDoc),
		RUNTIME_CLASS(CAviChildFrame), //   MDI ڽ Դϴ.
		RUNTIME_CLASS(CAviView));
	if (!m_pAviDocTemplate)
		return FALSE;
	AddDocTemplate(m_pAviDocTemplate);


	//  MDI  â ϴ.
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame || !pMainFrame->LoadFrame(IDR_MAINFRAME))
	{
		delete pMainFrame;
		return FALSE;
	}
	m_pMainWnd = pMainFrame;

	// ̻簡  쿡 DragAcceptFiles ȣմϴ.
	//  MDI  α׷ m_pMainWnd   ٷ ̷ ȣ ߻ؾ մϴ.
	//  ⿡  ⸦ Ȱȭմϴ.
	m_pMainWnd->DragAcceptFiles();

	// DDE Execute ⸦ Ȱȭմϴ.
	EnableShellOpen();
	RegisterShellFileTypes(TRUE);

	// ǥ  , DDE,  ⿡    мմϴ.
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// α׷    â  ʴ´.
	if ( cmdInfo.m_nShellCommand == CCommandLineInfo::FileNew )
		cmdInfo.m_nShellCommand = CCommandLineInfo::FileNothing;

	// ٿ   ġմϴ.
	//  α׷ /RegServer, /Register, /Unregserver Ǵ /Unregister ۵  FALSE ȯմϴ.
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	//  â ʱȭǾǷ ̸ ǥϰ Ʈմϴ.
	pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->UpdateWindow();

	return TRUE;
}



//  α׷  Ǵ CAboutDlg ȭ Դϴ.

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// ȭ  Դϴ.
	enum { IDD = IDD_ABOUTBOX };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV Դϴ.

// Դϴ.
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()

// ȭ ڸ ϱ   α׷ Դϴ.
void CImageToolApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

// CImageToolApp ޽ ó

/////////////////////////////////////////////////////////////////////////////
//  Լ 
void AfxNewImage(CDib& dib)
{
	CImageToolApp* pApp = (CImageToolApp*)AfxGetApp();
	pApp->m_pNewDib = &dib;
	AfxGetMainWnd()->SendMessage(WM_COMMAND, ID_FILE_NEW);
}

void CImageToolApp::OnEditPaste()
{
	CDib dib;
	dib.PasteFromClipboard();

	AfxNewImage(dib);
}

void CImageToolApp::OnUpdateEditPaste(CCmdUI *pCmdUI)
{
	pCmdUI->Enable(IsClipboardFormatAvailable(CF_DIB));
}

void CImageToolApp::OnWindowCloseall()
{
	m_pImageDocTemplate->CloseAllDocuments(FALSE);
}
