// ImageToolDoc.h : CImageToolDoc Ŭ ̽
//


#pragma once
#include "dib.h"


class CImageToolDoc : public CDocument
{
protected: // serialization ϴ.
	CImageToolDoc();
	DECLARE_DYNCREATE(CImageToolDoc)

// ƯԴϴ.
public:

// ۾Դϴ.
public:

// Դϴ.
public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);

// Դϴ.
public:
	virtual ~CImageToolDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

//  ޽  Լ
protected:
	DECLARE_MESSAGE_MAP()

public:
	// ̹ ü
	CDib m_Dib;

	//  ҷ & ϱ
	virtual BOOL OnOpenDocument(LPCTSTR lpszPathName);
	virtual BOOL OnSaveDocument(LPCTSTR lpszPathName);

public:
	// 5忡 ߰ Լ
	afx_msg void OnWindowDuplicate();
	afx_msg void OnEditCopy();

	// 6忡 ߰ Լ
	afx_msg void OnImageInverse();
	afx_msg void OnImageBrightness();
	afx_msg void OnImageContrast();
	afx_msg void OnGammaCorrection();
	afx_msg void OnViewHistogram();
	afx_msg void OnHistoEqualize();

	// 7忡 ߰ Լ
	afx_msg void OnImageArithmetic();
	afx_msg void OnBitplaneSlicing();

	// 8忡 ߰ Լ
	afx_msg void OnFilterMean();
	afx_msg void OnFilterWeightedMean();
	afx_msg void OnFilterGaussian();
	afx_msg void OnFilterLaplacian();
	afx_msg void OnFilterUnsharpMask();
	afx_msg void OnAddNoise();
	afx_msg void OnFilterMedian();
	afx_msg void OnFilterDiffusion();

	// 9忡 ߰ Լ
	afx_msg void OnImageTranslation();
	afx_msg void OnImageResize();
	afx_msg void OnImageRotate();
	afx_msg void OnImageMirror();
	afx_msg void OnImageFlip();

	// 10忡 ߰ Լ
	afx_msg void OnFourierDft();
	afx_msg void OnFourierDftrc();
	afx_msg void OnFourierFft();
	afx_msg void OnIdealLowpass();
	afx_msg void OnIdealHighpass();
	afx_msg void OnGaussianLowpass();
	afx_msg void OnGaussianHighpass();

	// 11忡 ߰ Լ
	afx_msg void OnEdgeRoberts();
	afx_msg void OnEdgePrewitt();
	afx_msg void OnEdgeSobel();
	afx_msg void OnHoughLine();
	afx_msg void OnHarrisCorner();

	// 12忡 ߰ Լ
	afx_msg void OnColorGrayscale();
	afx_msg void OnUpdateColorGrayscale(CCmdUI *pCmdUI);
	afx_msg void OnColorSplitRgb();
	afx_msg void OnUpdateColorSplitRgb(CCmdUI *pCmdUI);
	afx_msg void OnColorSplitHsi();
	afx_msg void OnUpdateColorSplitHsi(CCmdUI *pCmdUI);
	afx_msg void OnColorSplitYuv();
	afx_msg void OnUpdateColorSplitYuv(CCmdUI *pCmdUI);
	afx_msg void OnColorCombineRgb();
	afx_msg void OnColorCombineHsi();
	afx_msg void OnColorCombineYuv();
	afx_msg void OnColorEdge();
	afx_msg void OnUpdateColorEdge(CCmdUI *pCmdUI);
	afx_msg void OnColorEqualize();
	afx_msg void OnUpdateColorEqualize(CCmdUI *pCmdUI);

	// 13忡 ߰ Լ
	afx_msg void OnSegmentBinarization();
	afx_msg void OnBinarizationIterative();
	afx_msg void OnSegmentLabeling();
	afx_msg void OnContourTracing();

	// 14忡 ߰ Լ
	afx_msg void OnMorphologyErosion();
	afx_msg void OnMorphologyDilation();
	afx_msg void OnMorphologyOpening();
	afx_msg void OnMorphologyClosing();
	afx_msg void OnGraymorphErosion();
	afx_msg void OnGraymorphDilation();
	afx_msg void OnGraymorphOpening();
	afx_msg void OnGraymorphClosing();

	// 15忡 ߰ Լ
	afx_msg void OnFourierDescriptor();
	afx_msg void OnInvariantMoments();
};
